﻿; ------------------------------------------------------------------------------------
; Befehle:
;
; ####################################################################################
; Befehl:       ENM\AddServer(Port.l, Type.l = #PB_Network_TCP)
;
; Parameter:    Port   : Port auf dem der Server auf Verbindungen warten soll
;               Type.l : TCP/UDP - Server. Default ist TCP
;
; Beschreibung: Startet einen Server
;
; Rückgabe:     Server-Handle wenn Erfolg, sonst #Null
; ####################################################################################
;
; ####################################################################################
; Befehl:       ENM\RemoveServer(Server)
;
; Parameter:    Server: Sever-ID
;
; Beschreibung: Beendet einen Server
;
; Rückgabe:     #Null
; ####################################################################################
;
; ####################################################################################
; Befehl:       ENM\OpenConnection(ServerName$, Port.l, Type = #PB_Network_TCP)
;
; Parameter:    ServerName$: HostName/IP des Servers zu dem verbunden werden soll
;               Port.l: Port auf den der Server läuft
;               Type: TCP/UDP - Verbindung. Default ist TCP
;
; Beschreibung: Stellt eine Netzwerkverbindung zu einem Server her
;
; Rückgabe:     Connection-ID
; ####################################################################################
;
; ####################################################################################
; Befehl:       ENM\CloseConnection(Connection, Server = #Null)
;
; Parameter:    Connection: Connection-ID
;               Server: #Null wenn es eine Verbing ist die zu einem Server verbindet,
;                       Server-ID wenn sie zu einem Client verbindet.
;
; Beschreibung: Schließt eine Netzwerk-Verbindung
;
; Rückgabe:     #Null
; ####################################################################################
;
; ####################################################################################
; Befehl:       ENM\SetCallbacks(Connection_Server, *CB.ENM_Callbacks)
;
; Parameter:    Connection_Server: Server-ID, Connection-ID
;               *CB: Pointer auf Callback-Struktur
;
; Beschreibung: Setzt die Callbacks für eine Verbindung/einen Server
;
; Rückgabe:     #Null
; ####################################################################################
;
; ####################################################################################
; Befehl:       ENM\GetConnectionData(Connection)
;
; Parameter:    Connection: Connection-ID
;
; Beschreibung: Liest die Extra-Daten für eine Verbindung
;
; Rückgabe:     Xtra-Data
; ####################################################################################
;
; ####################################################################################
; Befehl:       ENM\SetConnectionData(Connection, XData)
;
; Parameter:    Connection: Connection-ID
;               XData: Extra-Daten
;
; Beschreibung: Schreibt die Extra-Daten für eine Verbindung
;
; Rückgabe:     #Null
; ####################################################################################
;
; ####################################################################################
; Befehl:       ENM\GetServerClientData(Server, Client)
;
; Parameter:    Server: Server-ID
;               Client: Client-ID
;
; Beschreibung: Liest die Extra-Daten für eine Verbindung an einem Server
;
; Rückgabe:     Xtra-Data
; ####################################################################################
;
; ####################################################################################
; Befehl:       ENM\SetServerClientData(Server, Client, Set)
;
; Parameter:    Server: Server-ID
;               Client: Client-ID
;               XData: Extra-Daten
;
; Beschreibung: Schreibt die Extra-Daten für eine Verbindung an einem Server
;
; Rückgabe:     #Null
; ####################################################################################
;   
; ------------------------------------------------------------------------------------
; IDE Options = PureBasic 4.51 (Windows - x64)
; CursorPosition = 49
; FirstLine = 25
; EnableXP
; CPU = 1